-- Import necessary modules
require "import"
import "android.widget.*"
import "android.view.*"
import "java.io.*"
import "java.lang.*"

-- Create layout
layout = {
    LinearLayout,
    orientation = "vertical",
    layout_width = "fill",
    layout_height = "fill",
    {
        EditText,
        id = "editText",
        layout_width = "fill",
        layout_height = "0dp",
        layout_weight = 1,
        hint = "Enter your command here...",
    },
    {
        Button,
        text = "Execute",
        layout_width = "fill",
        onClick = function()
            local command = editText.getText().toString()
            if command == "" then
                outputView.setText("No command to execute")
            else
                executeCommand(command)
            end
        end
    },
    {
        TextView,
        id = "outputView",
        layout_width = "fill",
        layout_height = "wrap_content",
    }
}

-- Set the layout
activity.setContentView(loadlayout(layout))

-- Function to execute command
function executeCommand(command)
    outputView.setText("") -- Clear the previous output
    local runtime = Runtime.getRuntime()
    local process = runtime.exec({"/system/bin/sh", "-c", command})

    -- Read the output
    local bufferedReader = BufferedReader(InputStreamReader(process.getInputStream()))
    local output = StringBuilder()
    local line = ""
    while true do
        line = bufferedReader.readLine()
        if line == nil then break end
        output.append(line).append("\n")
    end

    -- Read the error
    bufferedReader = BufferedReader(InputStreamReader(process.getErrorStream()))
    local errorOutput = StringBuilder()
    line = ""
    while true do
        line = bufferedReader.readLine()
        if line == nil then break end
        errorOutput.append(line).append("\n")
    end

    -- Show the output or error
    if tostring(output) ~= "" then
        outputView.setText(output.toString())
    else
        if tostring(errorOutput) ~= "" then
            outputView.setText(errorOutput.toString())
        else
            outputView.setText("No output")
        end
    end
end